library fm_validationengine;

import 'dart:convert';

import 'package:flutter/services.dart';
import 'package:flutter_js/flutter_js.dart';

class ValidationEngine {
  String? _bundleasset;

  get _bundle {
    if (_bundleasset == null) {
      throw Exception('Validation Engine not initialized');
    }
    return _bundleasset;
  }

  Future<void> init() async {
    _bundleasset = await rootBundle
        .loadString('packages/fm_validationengine/assets/bundle.js');
  }

  dynamic _evaluate(String js) {
    final evalResult = getJavascriptRuntime().evaluate('$_bundle; $js;');
    if (evalResult.isError) {
      throw Exception('QuickJS: $evalResult');
    }
    return evalResult.rawResult;
  }

  Map<String, dynamic> and(Map<String, dynamic> r1, Map<String, dynamic> r2) {
    final result =
        _evaluate('core.RuleBuilder.AND(${jsonEncode(r1)},${jsonEncode(r2)});');
    return jsonDecode(jsonEncode(result));
  }

  Map<String, dynamic> or(Map<String, dynamic> r1, Map<String, dynamic> r2) {
    final result =
        _evaluate('core.RuleBuilder.OR(${jsonEncode(r1)},${jsonEncode(r2)});');
    return jsonDecode(jsonEncode(result));
  }

  bool validate(Map<String, dynamic> data, Map<String, dynamic> fdoRule) {
    final evalResult = _evaluate(
        'core.validateRule(${jsonEncode(data)},${jsonEncode(fdoRule)});');
    return evalResult.toString() == 'true';
  }
}
