import 'package:flutter_test/flutter_test.dart';

import 'package:fm_validationengine/fm_validationengine.dart';

void main() {
  TestWidgetsFlutterBinding.ensureInitialized();
  test("basic test", () async {
    final data = {
      "true": true,
      '1': 1,
      '[1,2]': [1, 2],
    };
    final rule = {
      "name": "basic rule",
      "conditions": {},
      "rules": {
        "r3": {
          "name": "r3",
          "property": "1",
          "conditions": {
            "\$isIn": [1, 2, 3, 4]
          }
        },
        "r4_false": {
          "name": "r4",
          "property": "[1,2]",
          "conditions": {
            "\$contains": [0]
          }
        }
      },
      "logic": "r3"
    };
    final rule2 = {
      "name": "basic rule 2",
      "conditions": {},
      "rules": {
        "r1": {
          "name": "r1",
          "property": "true",
          "conditions": {
            "\$is": [true]
          }
        },
        "r2_false": {
          "name": "r2",
          "property": "true",
          "conditions": {
            "\$isNot": [true]
          }
        },
      },
      "logic": "r1",
    };

    final ve = ValidationEngine();
    await ve.init();
    expect(ve.validate(data, ve.and(rule, rule2)), true);
  });
}
